;	V01	05/09/2007		Nicola Perotto

#include hardware.inc
	__CONFIG _CONFIG1, _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON &_LVP_OFF & _DEBUG_OFF & _MCLR_OFF & _INTRC_IO
	__CONFIG _CONFIG2, _IESO_OFF & _FCMEN_OFF

IDLOCS	CODE
	dw	'N'
	dw	'P'
	dw	0x01
	dw	0x19

;Variable definition
;No variables required

	ORG	0
;----------------------------------------------------------------------
;		Reset vector
;----------------------------------------------------------------------
Reset
	nop					;required by ICD2 for debugging on some cpu
	clrf	PCLATH		;reset PCLATH
	goto	Start
	nop
;----------------------------------------------------------------------
;		 Interrupt vector
;----------------------------------------------------------------------
Interrupt
;Not used

		ORG 0x0004
Start
	call	Init

;******************************************************************************
;******************************************************************************
mainloop
	BANKSEL	0
	bcf		out_audio		;turn off speaker
	bcf		out_led			;turn off led
	btfss	in_start		;no debounce!
	goto	mainloop

	bsf		out_led			;led on

;Init flash memory readback
	BANKSEL	0
	movlw	low(AudioData)
	BANKSEL	EEADR			; Bank 2
	movwf	EEADR

	BANKSEL	0
	movlw	high(AudioData)
	BANKSEL	EEADRH			; Bank 2
	movwf	EEADRH

	BANKSEL	EECON1			; Bank 3
	bsf		EECON1,EEPGD	; Point to PROGRAM memory

	bsf		STATUS,RP1		; to minimize code inside the sound loop the bank is switched
soundloop					; only from 2 to 3 using direct RP1 manipulation
	bsf		STATUS,RP0		; Bank 3
;	BANKSEL	EECON1			; Bank 3 (I dont use the macro to save code)

;	bsf		EECON1,EEPGD	; Point to PROGRAM memory - already set outside the loop
	bsf		EECON1,RD		; do EE Read
	NOP						; Any instructions here are ignored as
	NOP						; program memory is read in second cycle
							; after BSF EECON1,RD
	bcf		STATUS,RP0		; Bank 2
;	BANKSEL	EEDATA			; Bank 2
;	BANKSEL	PORTB			; Bank 0 or 2 -> this is a trick!

	nop					;18	additional Delay
	nop					;19	additional Delay
	nop					;20	additional Delay
	nop					;21	additional Delay
	nop					;22	additional Delay

Bit7
	rlf		EEDATA,f		;shift the msb bit to C
	btfsc	STATUS,C		;send C to output pin
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay			;required delay to have the same timing for each bit

Bit6
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay

Bit5
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay

Bit4
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay

Bit3
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay

Bit2
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay

Bit1
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

	call	Delay

Bit0
	rlf		EEDATA,f
	btfsc	STATUS,C
	bsf		out_audio
	btfss	STATUS,C
	bcf		out_audio

;	call	Delay			;not required because of code that follows!

	incf	EEADR,f			;increment memory pointer, low byte
	btfsc	STATUS,Z
	incf	EEADRH,f		;increment memory pointer, high byte
	movf	EEADRH,f		;test EEADRH for 0
	btfss	STATUS,Z		;because at memory end EEADRH reset to zero
	goto	soundloop

	goto	mainloop


Delay		;call = +2
	nop		;1
	nop		;2
	nop		;3
	nop		;4
	nop		;5
	nop		;6
	nop		;7
	nop		;8

	nop		;9			;Additional delay
	nop		;10			;Additional delay
	nop		;11			;Additional delay
	nop		;12			;Additional delay
	nop		;13			;Additional delay
	return	;+2


Init					;Initialize processor
	clrf	INTCON		;interrupt disable

	BANKSEL	PORTA
	movlw	pwon_a
	movwf	PORTA
	movlw	pwon_b
	movwf	PORTB
	movlw	cADCON0
	movwf	ADCON0

	BANKSEL	OSCTUNE		;Bank 1
	movlw	cOSCCON
	movwf	OSCCON
;	movlw	cOSCTUNE
;	movwf	OSCTUNE

 	movlw   tris_a
	movwf   TRISA		;porta A
	movlw   tris_b
	movwf   TRISB           ;porta B
	movlw	cADCON1
	movwf	ADCON1
	movlw	cANSEL
	movwf	ANSEL

	movlw	B'10001111'	;Prescaler on WDT, 1:128 - No Pullup
	movwf	OPTION_REG

	clrf	PIE1
	clrf	PIE2
	movlw	B'00000011'
	movwf	PCON
	
	movlw	b'00000111'	;only 876A + 88
	movwf	CMCON
	clrf	CVRCON
	
	BANKSEL	0
	clrf	PIR1
	clrf	PIR2
	clrf	T1CON
	clrf	T2CON
	clrf	CCP1CON
	return

;******************************************************************************
	RADIX DEC

	ORG		256
AudioData		;Label
#include audio.asm		;the file produced by Roman Black software!

	end
